
#include <tigcclib.h>

#define PC89_92 PSEUDO_CONST_SCREEN

#if defined(OPTIMIZE_CALC_CONSTS) && ((defined(USE_TI92PLUS) || defined(USE_V200)) && defined(USE_TI89))
	#error "Optomize calc consts does not optomize here don't use it!"
#endif

//#define NO_REMOVE_NONALPHA
//#define FIXED_LEN
//#define JUST_NUMBERS
#define INSTALL_HOOK

//preforms a coppy word by word of 2 byte aligned arrays in inline asm
#define asmCpy(dest,src,len) ({const short *_src=src;short *_dest=dest;short _len=(len-1);\
                             asm volatile("0:\n	move.b (%0)+,(%1)+\n	dbf %2,0b":\
                             "+a"(_src),"+a"(_dest),"+d"(_len));})

//compares two char arays len bytes long in inline asm returns 0xFF or 0
#define asmCmp(src1,src2,len) ({const void *tmp0=src1,*tmp1=src2;short tmp2=len-1;\
                              asm("0:\n	cmp.b (%0)+,(%1)+\n	dbne %2,0b\n	sne %2":\
                              "+a"(tmp1),"+a"(tmp0),"+d"(tmp2));(char)tmp2;})

#ifdef INSTALL_HOOK
	//this is hardcoded because it can't be efectively calculated
	#define HOOK_SIZE 62
	extern const void TSR_end,TSR_begin,T4Hdl,old_t4_addr,move_init_delay,move_between_delay;
	
	static void install_hook(short rate,short delay){
		void *oldTrap4=GetIntVec(TRAP_4);
		//we compare as much of the hook as we can so that we don't modify the worong hook
		if(!asmCmp((oldTrap4-14),&TSR_begin,26))
		{
			asm("move.w %0,((move_init_delay-T4Hdl)+2,%1)"::"g"(delay),"a"(oldTrap4):"memory");
			asm("move.w %0,((move_between_delay-T4Hdl)+2,%1)"::"g"(rate),"a"(oldTrap4):"memory");
			return;
		}
		if(((void*)0x200000)>oldTrap4){
			if(DlgMessage("Warning","Diffrent Hook allready installed. Would you like to Proced?",BT_YES,BT_NO)==KEY_ESC)return;
		}
		HANDLE tsrH=HeapAllocHigh(HOOK_SIZE);
		if(!tsrH){
			ERD_dialog(ER_MEMORY,FALSE);
			return;
		}
		void *dest=HeapDeref(tsrH);
		asmCpy(dest,&TSR_begin,HOOK_SIZE);
		asm("move.w %0,((move_init_delay-TSR_begin)+2,%1)"::"g"(delay),"a"(dest):"memory");
		asm("move.w %0,((move_between_delay-TSR_begin)+2,%1)"::"g"(rate),"a"(dest):"memory");
		*(INT_HANDLER*)(dest+(*(short*)(dest+12)))=oldTrap4;
		SetIntVec(TRAP_4,(dest+14));
	}

	static void uninstall_hook(){
		void *oldTrap4=GetIntVec(TRAP_4);
		if(!asmCmp(oldTrap4-14,&TSR_begin,12))
		{
			HANDLE oldTsrH=HeapPtrToHandle(oldTrap4-14);
			if(!oldTsrH){
				return;
			}
			SetIntVec(TRAP_4,*(INT_HANDLER*)((oldTrap4-14)+(*(short*)(oldTrap4-2))));
			HeapFree(oldTsrH);
			ST_helpMsg("hook uninstalled!");
			return;
		}
	}
#endif

#ifndef FIXED_LEN
	HANDLE handles[4];
	#define INPUT_LEN 0
#else
	#ifndef INPUT_LEN
		#define INPUT_LEN 10
	#endif
#endif

#define FIRST_FIELD 0
#define FIRST_EDIT KID_EDIT
#define LAST_EDIT CUR_EDIT
#define NUM_EDITS ((LAST_EDIT-FIRST_EDIT)+1)
	enum{KID_EDIT=FIRST_FIELD,KBD_EDIT,APD_EDIT,CUR_EDIT,DIALOG_TITLE,DIALOG_FALGS};

CALLBACK short DlgCallback(short x __attribute__((unused)), long y __attribute__((unused)))
{
#ifndef FIXED_LEN
	if(x==DB_GET_EDIT_HANDLE){
		return handles[y-FIRST_EDIT];
	}
#endif
#if defined(JUST_NUMBERS) && !defined(NO_REMOVE_NONALPHA)
	if(x>LAST_EDIT || x<FIRST_EDIT)
			return DB_CONTINUE;
		char *dummy,*str;
		#ifndef FIXED_LEN
			void **__jmp_tbl=(*(void***)0xC8);
			str=HeapDeref(handles[x-FIRST_EDIT]);
		#else
			str=((char*)y);
		#endif
		short RT=DB_REDRAW_AND_CONTINUE;
		while(*str!=0){
			if(!isdigit(*str)){
					RT=DB_REDRAW;
					asm volatile("0:\n"
					"	move.b 1(%0),(%0)+\n"
					"	bne 0b":"=a"(dummy):"0"(str));
			}else{
				str++;
			}
		}
		return RT;
#else
	return DB_CONTINUE;
#endif
}

#ifndef FIXED_LEN
	#define StrToNum(idx,str) _StrToNum(idx)
#else
	#define StrToNum(idx,str) _StrToNum(GetStr(idx,str))
#endif

#ifndef FIXED_LEN
	#define push_edit_string(str,idx) ({extern short throw_err;short dummy;\
				if(!NG_tokenize(handles[idx],&throw_err,&dummy)){\
					asm("or.w #0xA000,%0\n""throw_err: .word 0xA000":"+m"(throw_err));\
				}})
#else
		#define push_edit_string(str,idx) push_parse_text(str)
#endif

#ifndef JUST_NUMBERS
	char Error;
#ifndef FIXED_LEN
	static unsigned long _StrToNum(long idx){
#else
	static unsigned long _StrToNum(char *str){
#endif
		ESI *top_estack_ptr=&top_estack,tmp_estack=*top_estack_ptr;
		unsigned long rtVal=0;
		TRY
			push_edit_string(str,idx);
			NG_approxESI(*top_estack_ptr);
			rtVal=estack_number_to_Float(*top_estack_ptr);
			Error=FALSE;
		ONERR
			ERD_dialog(errCode,FALSE);
			Error=0xFF;
		ENDTRY
		*top_estack_ptr=tmp_estack;
		return rtVal;
	}
#else
	#define Error 0
#ifndef FIXED_LEN
	static unsigned long _StrToNum(short idx){
		char *str=HeapDeref(handles[idx]);
#else
	static unsigned long _StrToNum(char *str){
#endif
		char c;
		long i;
	  unsigned long value=0;
	  for(;;){
			c=*str++;
			if(!isdigit(c))return value;
			i=c-'0';
//this is an optomization if it screws up in the future, remove it
			asm("":"+d"(i));
	  	value=(value<<3)+(value*2)+i;
	  }
	}
#endif

static unsigned long GetTimer(short timer_no)
{
	OSTimerRestart(timer_no);
	return OSTimerCurVal (timer_no);
}

static short GetInitBetweenKeyDelay()
{
	short rate;
	_OSInitBetweenKeyDelay(rate=OSInitBetweenKeyDelay(0));
	return rate;
}

static short GetInitKeyInitDelay()
{
	short rate=OSInitKeyInitDelay(0);
	OSInitKeyInitDelay(rate);
	return(rate);
}

	#if !((defined(USE_TI92PLUS) || defined(USE_V200)) && defined(USE_TI89))
		#ifndef USE_TI89
			#define ItemsNum 5
		#else
			#define ItemsNum 6
		#endif

			#ifndef FIXED_LEN
				#define EDIT_TYPE D_HEDIT
			#else
				#define EDIT_TYPE D_EDIT_FIELD
			#endif

	#define Strs 	  "OS settings\0Key repeat delay\0Key repeat rate\0Power down time\0Cursor blink rate"

	  static const SIZED_DIALOG(ItemsNum,sizeof(Strs)) input_dialog={offsetof(SIZED_DIALOG(ItemsNum,0),String),ItemsNum,PC89_92(120,165),PC89_92(65,80),DlgCallback,
		  {
		  {
		  	EDIT_TYPE,DF_TAB_SPACES, 1,15,{.dEdit={sizeof("OS settings"),0,9,8}}
		  },
		  {
		  	EDIT_TYPE,DF_TAB_SPACES,1,PC89_92(25,28),{.dEdit={sizeof("OS settings\0Key repeat delay"),10,9,8}}
		  },
		  {
		  	EDIT_TYPE,DF_TAB_SPACES,1,PC89_92(35,41),{.dEdit={sizeof("OS settings\0Key repeat delay\0Key repeat rate"),20,9,8}}
		  },
		  {
		  	EDIT_TYPE,DF_TAB_SPACES,1,PC89_92(45,54),{.dEdit={sizeof("OS settings\0Key repeat delay\0Key repeat rate\0Power down time"),30,9,8}}
		  },
		  {//Title
		  	D_HEADER,DF_SKIP,0,0,{.dHeader={0,BT_OK,BT_CANCEL}}
		  },
		#ifdef USE_TI89
		  {//Title
		  	D_XFLAGS,DF_SKIP,0,0,{.dFlags={{XF_NO_ALPHA_LOCK,0,0,0}}}
		  },
		#endif
			{//End : nothing
				.f={}
			}
		  },
		  Strs
		};
	#endif

//#ifndef FIXED_LEN
	enum{KID_idx=0,KBD_idx,APD_idx,CUR_idx,NUM_HANDLES};
#ifndef FIXED_LEN
	#define GetStr(idx,str) _GetStr(2*idx)//((char*)HeapDeref(handles[idx]))
	static char *_GetStr(register long offset){
		return HeapDeref(*(short*)(((void*)handles)+offset));
	}
#else
	#define GetStr(idx,str) ((char*)(str+INPUT_LEN*idx))
#endif

#ifndef FIXED_LEN
	#define DialogAddEdit(h,flags,x,y,label,offset,MaxLen,width) (DialogAddDynamicRequest(h,flags,x,y,label,width))
#else
	#define DialogAddEdit DialogAddRequestEx
#endif

static short SettingsDialog(char *str){
	#ifndef FIXED_LEN
		str=NULL;
	#endif
	#if (defined(USE_TI92PLUS) || defined(USE_V200)) && defined(USE_TI89)
		short key;
		HANDLE dlgH=DialogNew(PC89_92(120,165),PC89_92(65,80),DlgCallback);
		DialogAddEdit(dlgH,DF_TAB_SPACES,1,15,"Key repeat delay",INPUT_LEN*KID_idx,9,8);
		DialogAddEdit(dlgH,DF_TAB_SPACES,1,PC89_92(25,28),"Key repeat rate",INPUT_LEN*KBD_idx,9,8);
		DialogAddEdit(dlgH,DF_TAB_SPACES,1,PC89_92(35,41),"Power down time",INPUT_LEN*APD_idx,9,8);
		DialogAddEdit(dlgH,DF_TAB_SPACES,1,PC89_92(45,54),"Cursor blink rate",INPUT_LEN*CUR_idx,9,8);
		DialogAddXFlags(dlgH,0,XF_NO_ALPHA_LOCK,0,0,0);
		DialogAddTitleEx(dlgH,0,"OS settings",BT_OK,BT_CANCEL);
		key=DialogDo(dlgH,CENTER,CENTER,str,NULL);
		HeapFree(dlgH);
		return key;
	#else
		return Dialog((DIALOG*)&input_dialog,CENTER,CENTER,str,NULL);
	#endif
}

static short initStrings(char *str  __attribute__((unused))){
	#ifndef FIXED_LEN
		//initialize Handles
		HANDLE *ptr=handles;
		short i=NUM_HANDLES-1;
		do{
			if(!(*ptr++=HeapAlloc(10)))return FALSE;
			asm("":"+d"(i));
		}while(i--);
	#endif
	sprintf(GetStr(APD_idx,str),"%lu",GetTimer(APD_TIMER));
	//initalize Cursor str
	sprintf(GetStr(CUR_idx,str),"%lu",GetTimer(CURSOR_TIMER));
	//initalize key init delay str
	sprintf(GetStr(KBD_idx,str),"%u",GetInitBetweenKeyDelay());
	//initalize key between delay str
	sprintf(GetStr(KID_idx,str),"%u",GetInitKeyInitDelay());
	return TRUE;
}

static void freeMem(void){
	#ifndef FIXED_LEN
		HANDLE *tmp=handles;
		short i=NUM_HANDLES-1;
		/*for(i=0;i<NUM_HANDLES;i++){
			HeapFreeIndir(tmp++);
		}*/
		//this does the same as the comented out code
		//but has been made more optimal by the inclution
		//of some asm. if it breaks replace it.
		do{
			HeapFreeIndir(tmp);
			asm("addq.l %2,%1":"+d"(i),"+a"(tmp):"I"(sizeof(HANDLE)));
		}while(i--);
	#endif
}

void _main(void){
	char settings[INPUT_LEN*NUM_EDITS];
	if(initStrings(settings)){
		if(KEY_ENTER==SettingsDialog(settings)){
			long pd;
			pd=StrToNum(CUR_idx,settings);
			if(!Error){
				OSFreeTimer (CURSOR_TIMER);
				OSRegisterTimer (CURSOR_TIMER,pd);
			}
			pd=StrToNum(APD_idx,settings);
			if(!Error){
				if(pd<20 && pd>0){
					pd=20;
				}
				OSFreeTimer (APD_TIMER);
				OSRegisterTimer (APD_TIMER,pd);
			}
			short rate,delay;
			delay=StrToNum(KID_idx,settings);
			if(!Error){
				OSInitKeyInitDelay(delay);
			}
			rate=StrToNum(KBD_idx,settings);
			if(!Error){
				_OSInitBetweenKeyDelay(rate);
			}
			#ifdef INSTALL_HOOK
				if(!Error && (delay!=48 || rate!=336)){
					install_hook(rate,delay);
				}else{
					uninstall_hook();
				}
			#endif
		}
	}
	freeMem();
}